diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index 2b2969cd3..a74e34b68 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -506,18 +368,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             this.vao = GL41.glGenVertexArrays();
             this.vbo = GL41.glGenBuffers();
 
-            GL41.glBindVertexArray(this.vao);
-            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
-
-            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
-            GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
-            GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, VERT_SIZE, Float.BYTES * 3);
-            GL41.glVertexAttrib2f(3, 15.5f/16f, 15.5f/16f);
-            GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, VERT_SIZE, Float.BYTES * 5);
-
-            GL41.glEnableVertexAttribArray(0);
-            GL41.glEnableVertexAttribArray(2);
-            GL41.glEnableVertexAttribArray(4);
+            enable(this.vao, this.vbo);
         }
 
         public void startDrawingQuads() {
@@ -538,15 +389,20 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             this.data.clear();
         }
 
+        public void addVertexWithUV(@NotNull Vector3dc pos, double u, double v) {
+            addVertexWithUV(pos.x(), pos.y(), pos.z(), u, v);
+        }
+
         public void addVertexWithUV(double x, double y, double z, double u, double v) {
             if(!this.drawing) {
-                throw new IllegalStateException("Entity Tessellator already drawing!");
+                throw new IllegalStateException("Entity Tessellator not drawing!");
             }
             checkCanFit(64);
 
             this.data.putFloat((float) x).putFloat((float) y).putFloat((float) z);
             this.data.putFloat((float) u).putFloat((float) v);
             this.data.put(this.normalX).put(this.normalY).put(this.normalZ);
+            this.data.putFloat(this.boneIndex + 0.05f);
 
             this.vertexCount++;
 
@@ -574,9 +430,17 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             }
         }
 
+        public void setBone(int boneIndex) {
+            if(!this.drawing) {
+                throw new IllegalStateException("Entity Tessellator not drawing!");
+            }
+
+            this.boneIndex = (byte) boneIndex;
+        }
+
         public void setNormal(double x, double y, double z) {
             if(!this.drawing) {
-                throw new IllegalStateException("Entity Tessellator already drawing!");
+                throw new IllegalStateException("Entity Tessellator not drawing!");
             }
 
             this.normalX = (byte) (x * 127.0);
@@ -584,21 +448,31 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             this.normalZ = (byte) (z * 127.0);
         }
 
-        public void draw() {
+        public @NotNull RenderBuffer record(int vao, int vbo) {
             if(!this.drawing) {
-                throw new IllegalStateException("Entity Tessellator already drawing!");
+                throw new IllegalStateException("Entity Tessellator not drawing!");
             }
-
             this.drawing = false;
 
-            if (this.vertexCount == 0) return;
-
-            GL41.glBindVertexArray(this.vao);
-            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
-            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
-            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
-            GL41.glDrawArrays(Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES.cap : DrawMode.QUADS.cap, 0, this.vertexCount);
+            enable(vao, vbo);
+            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
             GL41.glBindVertexArray(0);
+            return new RenderBuffer(vao, vbo, 0, this.vertexCount, Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES : DrawMode.QUADS);
+        }
+
+        public void enable(int vao, int vbo) {
+            GL41.glBindVertexArray(vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
+            GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false, VERT_SIZE, Float.BYTES * 3);
+            GL41.glVertexAttribPointer(2, 3, GL41.GL_BYTE, true, VERT_SIZE, Float.BYTES * 5);
+            GL41.glVertexAttribPointer(3, 1, GL41.GL_FLOAT, false, VERT_SIZE, Float.BYTES * 5 + 3);
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(1);
+            GL41.glEnableVertexAttribArray(2);
+            GL41.glEnableVertexAttribArray(3);
         }
     }
 }
diff --git a/game/client/src/main/resources/shaders/aurora.fsh b/game/client/src/main/resources/shaders/aurora.fsh
new file mode 100644
index 000000000..0baabf72b
--- /dev/null
+++ b/game/client/src/main/resources/shaders/aurora.fsh
@@ -0,0 +1,31 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+
+uniform float uAlphaTest;
+uniform vec4 uColor;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform sampler2D colortex;
+
+
+void main() {
+    vec4 texColor = texture(colortex, TexCoord);
+
+    vec4 oColor = texColor * Color * uColor;
+    vec4 litColor = vec4(oColor.rgb, oColor.a);
+
+    FragColor = litColor;
+    if (FragColor.a < uAlphaTest) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/aurora.vsh b/game/client/src/main/resources/shaders/aurora.vsh
new file mode 100644
index 000000000..dc194b67a
--- /dev/null
+++ b/game/client/src/main/resources/shaders/aurora.vsh
@@ -0,0 +1,27 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec3 aPosO;
+layout (location = 2) in vec4 aColor;
+layout (location = 3) in vec4 aColorO;
+layout (location = 4) in vec2 aUV;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+
+uniform mat4 model;
+uniform float uPartialTick;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+void main() {
+    gl_Position = matrices.projection * matrices.view * model * vec4(mix(aPosO, aPos, uPartialTick), 1);
+
+    TexCoord = aUV;
+    Color = mix(aColorO, aColor, uPartialTick);
+}
diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index 7af39eadc..a482602c3 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -23,6 +23,7 @@ layout (std140) uniform Matrices {
 	mat4 viewInv;
 } matrices;
 
+uniform float uAlphaTest;
 uniform int isEyeInLiquid;
 uniform vec2 uViewPortSize;
 
@@ -40,7 +41,7 @@ void main() {
 	vec4 tex = texture(colortex, TexCoord);
 	
 	// Alpha test
-	if(tex.a < 0.1) {
+	if(tex.a < uAlphaTest) {
 		discard;
 	}
 	
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
index 7f3d1bcb4..dfd85c2ff 100644
--- a/game/client/src/main/resources/shaders/color_world.fsh
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -6,6 +6,7 @@ in vec4 Color;
 in vec2 LightMapCoord;
 in vec3 Light;
 
+uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
 
@@ -70,7 +71,7 @@ void main() {
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
 
     FragColor = computeFog(oColor);
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/entity.fsh b/game/client/src/main/resources/shaders/entity.fsh
new file mode 100644
index 000000000..380af1944
--- /dev/null
+++ b/game/client/src/main/resources/shaders/entity.fsh
@@ -0,0 +1,82 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec2 TexCoord;
+in vec3 Light;
+
+uniform float uAlphaTest;
+uniform vec4 uColor;
+uniform vec2 uLightmap;
+uniform vec2 uViewPortSize;
+
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform sampler2D colortex;
+uniform sampler2D lighttex;
+
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = fogState.density * (distance());
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (fogState.mode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (fogState.mode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (fogState.mode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
+}
+
+void main() {
+    vec4 lightColor = texture(lighttex, uLightmap);
+    vec4 texColor = texture(colortex, TexCoord);
+
+    vec4 oColor = texColor * lightColor * uColor;
+    vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
+
+    vec4 fColor = computeFog(litColor);
+
+
+    FragColor = fColor;
+    if (FragColor.a < uAlphaTest) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/entity.vsh b/game/client/src/main/resources/shaders/entity.vsh
new file mode 100644
index 000000000..fb562c06c
--- /dev/null
+++ b/game/client/src/main/resources/shaders/entity.vsh
@@ -0,0 +1,40 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec2 aUV;
+layout (location = 2) in vec3 aNormal;
+layout (location = 3) in float abone;
+
+out vec2 TexCoord;
+out vec3 Light;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition1;
+uniform vec4 lightSourcePosition2;
+uniform vec4 lightSourceDiffuse1;
+uniform vec4 lightSourceDiffuse2;
+
+uniform mat4 model;
+uniform mat4 texture;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+layout (std140) uniform Bones {
+    mat4 transforms[128];
+} bones;
+
+void main() {
+    mat4 bone = bones.transforms[int(abone)];
+    gl_Position = matrices.projection * matrices.view * model * bone * vec4(aPos, 1);
+    TexCoord = (texture * vec4(aUV, 0.0, 1.0)).xy;
+
+    vec4 norm = normalize(normalTransform * model * bone * vec4(aNormal, 0));
+    float dir1 = max(0.0, dot(norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(norm, lightSourcePosition2));
+    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
+}
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index 69ed2922c..d80227c35 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -5,6 +5,7 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 Lightmap;
 
+uniform float uAlphaTest;
 uniform vec4 uColor;
 
 uniform sampler2D colortex;
@@ -12,7 +13,7 @@ uniform sampler2D lighttex;
 
 void main() {
     FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color * uColor;
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/lines.fsh b/game/client/src/main/resources/shaders/lines.fsh
index 228db697d..81ac31e41 100644
--- a/game/client/src/main/resources/shaders/lines.fsh
+++ b/game/client/src/main/resources/shaders/lines.fsh
@@ -1,12 +1,14 @@
 #version 410 core
 out vec4 FragColor;
 
+uniform float uAlphaTest;
+
 in vec4 Color;
 uniform vec4 uColor;
 
 void main() {
     FragColor = Color * uColor;
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index 66678e4fa..0208364de 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -5,12 +5,14 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 Lightmap;
 
+uniform float uAlphaTest;
+
 uniform sampler2D colortex;
 uniform sampler2D lighttex;
 
 void main() {
     FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color;
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index 5d742d0ea..fda0727cb 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -8,6 +8,7 @@ in vec2 LightMapCoord;
 in vec3 Light;
 in vec3 Norm;
 
+uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
 
@@ -87,7 +88,7 @@ void main() {
 
 
     FragColor = fColor;
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
index 802eb8b50..990459bfb 100644
--- a/game/client/src/main/resources/shaders/world.fsh
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -7,6 +7,7 @@ in vec2 TexCoord;
 in vec2 LightMapCoord;
 in vec3 Light;
 
+uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
 
@@ -76,7 +77,7 @@ void main() {
 
 
     FragColor = fColor;
-    if (FragColor.a < 0.1) {
+    if (FragColor.a < uAlphaTest) {
         discard;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
index 9725c8391..c4681562b 100644
--- a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
+++ b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
@@ -2,6 +2,7 @@ package net.minecraft.core;
 
 
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -14,20 +15,20 @@ public class NextTickListEntry
     private static long counter = 0L;
 
     public @NotNull TilePos tilePos;
-    public int blockId;
+    public @NotNull Block<?> block;
     public long delay;
     private final long entryId;
 
-    public NextTickListEntry(final @NotNull TilePosc tilePos, final int blockId) {
+    public NextTickListEntry(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         this.entryId = counter++;
         this.tilePos = new TilePos(tilePos);
-        this.blockId = blockId;
+        this.block = block;
     }
 
     @Override
     public boolean equals(final @Nullable Object obj) {
         if (obj instanceof final @NotNull NextTickListEntry entry) {
-            return this.tilePos.equals(entry.tilePos) && this.blockId == entry.blockId;
+            return this.tilePos.equals(entry.tilePos) && this.block == entry.block;
         } else {
             return false;
         }
@@ -35,7 +36,7 @@ public class NextTickListEntry
 
     @Override
     public int hashCode() {
-        return (this.tilePos.x() * 128 * 1024 + this.tilePos.z() * 128 + this.tilePos.y()) * 256 + this.blockId;
+        return (this.tilePos.x() * 128 * 1024 + this.tilePos.z() * 128 + this.tilePos.y()) * 256 + this.block.id();
     }
 
     public @NotNull NextTickListEntry setDelay(final long delay) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index ffcd2c3d3..5089647be 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -261,7 +261,7 @@ public final class Block<T extends BlockLogic>
 
     @Override
     public @NotNull Item asItem() {
-        return Item.itemsList[this.id];
+        return Objects.requireNonNull(Item.itemsList[this.id]);
     }
 
     @Override
@@ -270,8 +270,7 @@ public final class Block<T extends BlockLogic>
     }
 
     public static boolean getIsLitInteriorSurface(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = source.getBlock(tilePos);
-        return block != null && block.isLitInteriorSurface;
+        return source.getBlockType(tilePos).isLitInteriorSurface;
     }
 
     @Deprecated
@@ -408,8 +407,8 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
-        this.logic.onNeighborChanged(world, tilePos, id);
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        this.logic.onNeighborChanged(world, tilePos, block);
     }
 
     @Override
@@ -594,6 +593,34 @@ public final class Block<T extends BlockLogic>
         return this.logic.getAttachedSide(source, tilePos);
     }
 
+    public boolean shouldTick() {
+        return Blocks.shouldTick[this.id];
+    }
+
+    public boolean solid() {
+        return Blocks.solid[this.id];
+    }
+
+    public boolean isEntityTile() {
+        return Blocks.isEntityTile[this.id];
+    }
+
+    public int lightBlock() {
+        return Blocks.lightBlock[this.id];
+    }
+
+    public boolean translucent() {
+        return Blocks.translucent[this.id];
+    }
+
+    public int lightEmission() {
+        return Blocks.lightEmission[this.id];
+    }
+
+    public boolean neighborNotifyOnDataChangeDisabled() {
+        return Blocks.neighborNotifyOnMetadataChangeDisabled[this.id];
+    }
+
     public static boolean hasLogicClass(@Nullable final Block<?> block, final @NotNull Class<?> logicClass) {
         return block != null && logicClass.isAssignableFrom(block.getLogic().getClass());
     }
@@ -601,4 +628,9 @@ public final class Block<T extends BlockLogic>
     public static @Nullable BlockLogic getLogicClass(final @Nullable  Block<?> block) {
         return block == null ? null : block.getLogic();
     }
+
+    @Override
+    public @NotNull String toString() {
+        return this.namespaceId().toString();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index 28afea31c..a3bd4dac6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -27,6 +27,7 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 import java.util.List;
+import java.util.Objects;
 import java.util.Random;
 
 interface BlockInterface {
@@ -167,11 +168,11 @@ interface BlockInterface {
         this.animationTick(world, new TilePos(x, y, z), rand);
     }
 
-    void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id);
+    void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block);
 
     @Deprecated
     default void onNeighborBlockChange(final @NotNull World world, final int x, final int y, final int z, final int id) {
-        this.onNeighborChanged(world, new TilePos(x, y, z), id);
+        this.onNeighborChanged(world, new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
     int tickDelay();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 0fc4f0620..77fa14be5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -118,7 +118,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
 
     @Override
     public @NotNull AABBdc getBounds() {
-        return this.bounds/*.AABB_copy()*/;
+        return this.bounds;
     }
 
     @Override
@@ -199,7 +199,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) { }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) { }
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) { }
 
     @Override
     public int tickDelay() {
@@ -483,7 +483,7 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
 
     @Override
     public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
-        final @Nullable Block<?> bBlock = world.getBlock(thatPos);
+        final @Nullable Block<?> bBlock = world.getBlockType(thatPos);
 
         final int thisMeta = world.getBlockData(thisPos);
         final int otherMeta = world.getBlockData(thatPos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index 3d92fcdec..c273b10ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -53,7 +53,7 @@ public class BlockLogicActivator
             final double pz = direction.getOffsetZ() * 0.6D + 0.5D;
 
             if (itemStack == null) {
-                final @Nullable Block<?> block = world.getBlock(tilePos.add(direction, new TilePos()));
+                final @Nullable Block<?> block = world.getBlockType(tilePos.add(direction, new TilePos()));
 
                 if (block != null) {
                     block.onActivatorInteracted(world, tilePos.add(direction, new TilePos()), activator, direction);
@@ -73,13 +73,13 @@ public class BlockLogicActivator
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final int meta = world.getBlockData(tilePos);
         final boolean hasSignal = this.getNeighborSignal(world, tilePos, BlockLogicRotatable.getDirectionFromMeta(meta));
         final boolean isPowered = (meta & MASK_POWERED) != 0;
 
         if (hasSignal && !isPowered) {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+            world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
         } else if (!hasSignal && isPowered) {
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
new file mode 100644
index 000000000..bc9aa1af8
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
@@ -0,0 +1,139 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBdc;
+
+import java.util.List;
+
+public class BlockLogicAir
+    extends BlockLogic {
+    public BlockLogicAir(final @NotNull Block<?> block) {
+        super(block, Materials.AIR);
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceOnSurface() {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
+        return null;
+    }
+
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
+        return null;
+    }
+
+    @Override
+    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList) {
+        // Do nothing
+    }
+
+    @Override
+    public boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        return null;
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public boolean canCollideCheck(final int data, final boolean shouldCollideWithFluids) {
+        return false;
+    }
+
+    @Override
+    public boolean isCollidable() {
+        return false;
+    }
+
+    @Override
+    public float getStrength(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Player player) {
+        return 0.0f;
+    }
+
+    @Override
+    public boolean getImmovable() {
+        return false;
+    }
+
+    @Override
+    public float getBlastResistance(final @Nullable Entity entity) {
+        return 0.0f;
+    }
+
+    @Override
+    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, @NotNull final Vector3dc start, @NotNull final Vector3dc end, final boolean useSelectionAABB) {
+        return null;
+    }
+
+    @Override
+    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return false;
+    }
+
+    @Override
+    public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
+        // Do nothing
+    }
+
+    @Override
+    public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
+        // Do nothing
+    }
+
+    @Override
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+}
